#ifndef _ATA_H_
#define _ATA_H_

#include <linux/hdreg.h>

#define CH0 0x1f0	/* Primary Master, 0 */
#define CH1 0x1E8	/* Primary Slave, 1 */
#define CH2 0x170	/* Secondary Master, 2 */
#define CH3 0x168	/* Secondary Slave, 3 */

/*     */
#define BSY	0x80
#define DRDY	0x40
#define DF	0x20
#define DSC	0x10
#define DRQ	0x08
#define CORR	0x04
#define IDX	0x02
#define ERR	0x01

#define GET_DEV(X) ((X & 0x00000F00) >> 8)
#define GET_PART(X) (X & 0x000000FF)

#define READ_FROM_DISK	0x20
#define WRITE_TO_DISK	0x30


/*
 *   
 */
typedef struct pt_struct {
    u8 bootable;
    u8 start_part[3];
    u8 type_part;
    u8 end_part[3];
    u32 sect_before;
    u32 sect_total;
} pt_t;

/*     (0x10)*/
#ifndef PT_SIZE
#define PT_SIZE 0x10
#endif

/*
 * status -     (0/1 - /ATA)
 * hd -    ()
 * pt -      
 */
struct dev_status_struct {
    u8 status;
    struct hd_driveid hd;
    pt_t pt[4];
} dev_status[4];

#define DEV_STAT(x) dev_status[x].status
#define DEV_ID(x) dev_status[x].hd
#define DEV_PT(x,y) dev_status[x].pt[y]
/*
 * x -  
 * y -  
 */

/*     */
#ifndef BLK_SIZE
#define BLK_SIZE 2048
#endif

/*      */
#ifndef BYTE_PER_SECT
#define BYTE_PER_SECT 512
#endif


#endif
